#!/bin/env python

import json
import sys, os
from itertools import chain
from urllib import urlencode
from urllib2 import urlopen

def parse(parser_input, server_grammar = None, local_grammar = None):
    server_url = ('https://inst.eecs.berkeley.edu/~cs164/fa10/'
                  'reference-parser/parser.cgi')              
    query_parameters = [('input', parser_input)]
    
    if server_grammar is not None:
        query_parameters.append(('server_grammar', server_grammar))
    if local_grammar is not None:
        query_parameters.append(('grammar', local_grammar))
    query = urlencode(query_parameters)

    response = json.load(urlopen(server_url, query))
    response2 = response[response.keys()[0]]
    
    if type(response2) == type({}) and 'error' in response2:
        print response2['error']
        exit(-1)
    else:
        ast = response2
        if ast == None:
            print "Syntax error in input file"
            exit(-1)
        else: return ast

output = parse(sys.argv[1], None, open('regex-to-NFA-dotty.grm').read()) 

file = open("nfa.dot", "w")
file.write(output)
file.close()

os.system("dotty nfa.dot")
os.system("dot -Tpdf -o nfa.pdf nfa.dot")
